# coding: utf-8

"""
    FlowHunt

    FlowHunt API

    The version of the OpenAPI document: 2.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from flowhunt.models.transaction_type import TransactionType
from typing import Optional, Set
from typing_extensions import Self

class CreditTransactionResponse(BaseModel):
    """
    CreditTransactionResponse
    """ # noqa: E501
    transaction_id: StrictStr = Field(description="Transaction ID")
    workspace_id: StrictStr = Field(description="Workspace ID")
    user_id: StrictStr = Field(description="User ID or user to whom is transaction assigned")
    created_at: datetime = Field(description="Transaction creation date")
    transaction_type: TransactionType = Field(description="Transaction type")
    context_id: StrictStr = Field(description="Context ID - identification of transaction context - eg chatbot id")
    context_desc: Optional[StrictStr] = Field(default=None, description="Context description - description of transaction context")
    amount: StrictInt = Field(description="Amount of credits")
    __properties: ClassVar[List[str]] = ["transaction_id", "workspace_id", "user_id", "created_at", "transaction_type", "context_id", "context_desc", "amount"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreditTransactionResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreditTransactionResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "transaction_id": obj.get("transaction_id"),
            "workspace_id": obj.get("workspace_id"),
            "user_id": obj.get("user_id"),
            "created_at": obj.get("created_at"),
            "transaction_type": obj.get("transaction_type"),
            "context_id": obj.get("context_id"),
            "context_desc": obj.get("context_desc"),
            "amount": obj.get("amount")
        })
        return _obj


