# coding: utf-8

"""
    FlowHunt

    FlowHunt API

    The version of the OpenAPI document: 2.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from flowhunt.models.faq_status import FaqStatus
from typing import Optional, Set
from typing_extensions import Self

class FaqResponse(BaseModel):
    """
    FaqResponse
    """ # noqa: E501
    faq_id: StrictStr = Field(description="FAQ ID")
    workspace_id: StrictStr = Field(description="Workspace ID")
    cat_id: StrictStr = Field(description="Category ID")
    question: StrictStr = Field(description="Question")
    answer: Optional[StrictStr] = None
    parent_faq_id: Optional[StrictStr] = None
    status: FaqStatus = Field(description="FAQ status")
    updated_at: datetime = Field(description="FAQ updated at")
    indexed_at: Optional[datetime] = None
    __properties: ClassVar[List[str]] = ["faq_id", "workspace_id", "cat_id", "question", "answer", "parent_faq_id", "status", "updated_at", "indexed_at"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of FaqResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if answer (nullable) is None
        # and model_fields_set contains the field
        if self.answer is None and "answer" in self.model_fields_set:
            _dict['answer'] = None

        # set to None if parent_faq_id (nullable) is None
        # and model_fields_set contains the field
        if self.parent_faq_id is None and "parent_faq_id" in self.model_fields_set:
            _dict['parent_faq_id'] = None

        # set to None if indexed_at (nullable) is None
        # and model_fields_set contains the field
        if self.indexed_at is None and "indexed_at" in self.model_fields_set:
            _dict['indexed_at'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of FaqResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "faq_id": obj.get("faq_id"),
            "workspace_id": obj.get("workspace_id"),
            "cat_id": obj.get("cat_id"),
            "question": obj.get("question"),
            "answer": obj.get("answer"),
            "parent_faq_id": obj.get("parent_faq_id"),
            "status": obj.get("status"),
            "updated_at": obj.get("updated_at"),
            "indexed_at": obj.get("indexed_at")
        })
        return _obj


