# coding: utf-8

"""
    FlowHunt

    FlowHunt API

    The version of the OpenAPI document: 2.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from flowhunt.models.faq_status import FaqStatus
from flowhunt.models.faq_type import FaqType
from flowhunt.models.pagination import Pagination
from typing import Optional, Set
from typing_extensions import Self

class FaqSearchRequest(BaseModel):
    """
    FaqSearchRequest
    """ # noqa: E501
    faq_id: Optional[StrictStr] = None
    status: Optional[FaqStatus] = None
    cat_id: Optional[StrictStr] = None
    question: Optional[StrictStr] = None
    answer: Optional[StrictStr] = None
    parent_faq_id: Optional[StrictStr] = None
    faq_type: Optional[FaqType] = None
    limit: Optional[StrictInt] = None
    pagination: Optional[Pagination] = None
    __properties: ClassVar[List[str]] = ["faq_id", "status", "cat_id", "question", "answer", "parent_faq_id", "faq_type", "limit", "pagination"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of FaqSearchRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of pagination
        if self.pagination:
            _dict['pagination'] = self.pagination.to_dict()
        # set to None if faq_id (nullable) is None
        # and model_fields_set contains the field
        if self.faq_id is None and "faq_id" in self.model_fields_set:
            _dict['faq_id'] = None

        # set to None if status (nullable) is None
        # and model_fields_set contains the field
        if self.status is None and "status" in self.model_fields_set:
            _dict['status'] = None

        # set to None if cat_id (nullable) is None
        # and model_fields_set contains the field
        if self.cat_id is None and "cat_id" in self.model_fields_set:
            _dict['cat_id'] = None

        # set to None if question (nullable) is None
        # and model_fields_set contains the field
        if self.question is None and "question" in self.model_fields_set:
            _dict['question'] = None

        # set to None if answer (nullable) is None
        # and model_fields_set contains the field
        if self.answer is None and "answer" in self.model_fields_set:
            _dict['answer'] = None

        # set to None if parent_faq_id (nullable) is None
        # and model_fields_set contains the field
        if self.parent_faq_id is None and "parent_faq_id" in self.model_fields_set:
            _dict['parent_faq_id'] = None

        # set to None if faq_type (nullable) is None
        # and model_fields_set contains the field
        if self.faq_type is None and "faq_type" in self.model_fields_set:
            _dict['faq_type'] = None

        # set to None if limit (nullable) is None
        # and model_fields_set contains the field
        if self.limit is None and "limit" in self.model_fields_set:
            _dict['limit'] = None

        # set to None if pagination (nullable) is None
        # and model_fields_set contains the field
        if self.pagination is None and "pagination" in self.model_fields_set:
            _dict['pagination'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of FaqSearchRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "faq_id": obj.get("faq_id"),
            "status": obj.get("status"),
            "cat_id": obj.get("cat_id"),
            "question": obj.get("question"),
            "answer": obj.get("answer"),
            "parent_faq_id": obj.get("parent_faq_id"),
            "faq_type": obj.get("faq_type"),
            "limit": obj.get("limit"),
            "pagination": Pagination.from_dict(obj["pagination"]) if obj.get("pagination") is not None else None
        })
        return _obj


