# coding: utf-8

"""
    FlowHunt

    FlowHunt API

    The version of the OpenAPI document: 2.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from flowhunt.models.flow_event_action_type import FlowEventActionType
from flowhunt.models.message_type import MessageType
from flowhunt.models.metadata import Metadata
from typing import Optional, Set
from typing_extensions import Self

class FlowSessionEvent(BaseModel):
    """
    FlowSessionEvent
    """ # noqa: E501
    workspace_id: StrictStr = Field(description="Workspace ID")
    session_id: StrictStr = Field(description="Session ID")
    event_id: StrictStr = Field(description="Event ID")
    event_type: MessageType = Field(description="Event type")
    created_at_timestamp: StrictStr = Field(description="Created at")
    action_type: FlowEventActionType = Field(description="Action type")
    credits: Union[StrictFloat, StrictInt] = Field(description="Credits")
    metadata: Optional[Metadata] = None
    component_name: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["workspace_id", "session_id", "event_id", "event_type", "created_at_timestamp", "action_type", "credits", "metadata", "component_name"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of FlowSessionEvent from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of metadata
        if self.metadata:
            _dict['metadata'] = self.metadata.to_dict()
        # set to None if metadata (nullable) is None
        # and model_fields_set contains the field
        if self.metadata is None and "metadata" in self.model_fields_set:
            _dict['metadata'] = None

        # set to None if component_name (nullable) is None
        # and model_fields_set contains the field
        if self.component_name is None and "component_name" in self.model_fields_set:
            _dict['component_name'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of FlowSessionEvent from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "workspace_id": obj.get("workspace_id"),
            "session_id": obj.get("session_id"),
            "event_id": obj.get("event_id"),
            "event_type": obj.get("event_type"),
            "created_at_timestamp": obj.get("created_at_timestamp"),
            "action_type": obj.get("action_type"),
            "credits": obj.get("credits"),
            "metadata": Metadata.from_dict(obj["metadata"]) if obj.get("metadata") is not None else None,
            "component_name": obj.get("component_name")
        })
        return _obj


