# coding: utf-8

"""
    FlowHunt

    FlowHunt API

    The version of the OpenAPI document: 2.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from flowhunt.models.google_ads_recommendation_confidence import GoogleAdsRecommendationConfidence
from flowhunt.models.google_ads_recommendation_status import GoogleAdsRecommendationStatus
from flowhunt.models.google_ads_recommendation_type import GoogleAdsRecommendationType
from typing import Optional, Set
from typing_extensions import Self

class GoogleAdsRecommendation(BaseModel):
    """
    GoogleAdsRecommendation
    """ # noqa: E501
    recommendation_type: GoogleAdsRecommendationType
    campaign_id: StrictStr
    campaign_name: Optional[StrictStr] = None
    group_id: StrictStr
    group_name: Optional[StrictStr] = None
    action_status: GoogleAdsRecommendationStatus
    confidence: Optional[GoogleAdsRecommendationConfidence] = None
    __properties: ClassVar[List[str]] = ["recommendation_type", "campaign_id", "campaign_name", "group_id", "group_name", "action_status", "confidence"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GoogleAdsRecommendation from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if campaign_name (nullable) is None
        # and model_fields_set contains the field
        if self.campaign_name is None and "campaign_name" in self.model_fields_set:
            _dict['campaign_name'] = None

        # set to None if group_name (nullable) is None
        # and model_fields_set contains the field
        if self.group_name is None and "group_name" in self.model_fields_set:
            _dict['group_name'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GoogleAdsRecommendation from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "recommendation_type": obj.get("recommendation_type"),
            "campaign_id": obj.get("campaign_id"),
            "campaign_name": obj.get("campaign_name"),
            "group_id": obj.get("group_id"),
            "group_name": obj.get("group_name"),
            "action_status": obj.get("action_status"),
            "confidence": obj.get("confidence")
        })
        return _obj


